package com.example.myview;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.CornerPathEffect;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.PathEffect;
import android.graphics.Typeface;
import android.icu.util.Measure;
import android.os.Bundle;
import android.util.AttributeSet;
import android.view.View;
import android.widget.TextView;

import java.util.List;

public class MyView extends View {
    private int widthMode;
    private int heightMode;
    private int widthSize;
    private int heightSize;
    private float[] dataList ={150,500,250,550,250,550,350,590,350,590,450,650,450,650,550,610,550,610,650,650} ;//数据
    private float[] dataList2 = {150,500,250,550,350,590,450,650,550,610,650,650};
    private String[] dataList3 = {"28℃","22℃","20℃","22℃","25℃","29℃"};
    private Paint paint = new Paint();
    //如果在Java代码中new，就会调用第一个构造方法C
    public MyView(Context context) {
        super(context);
    }
    //如果View是在.xml里面声明的就会调用第二个构造函数
    public MyView(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
    }

    @Override
    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        super.onMeasure(widthMeasureSpec, heightMeasureSpec);
        widthMode = MeasureSpec.getMode(widthMeasureSpec);
        heightMode = MeasureSpec.getMode(heightMeasureSpec);
        widthSize = MeasureSpec.getSize(widthMeasureSpec);
        heightSize = MeasureSpec.getSize(heightMeasureSpec);

        initPaint();
    }


    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        if (dataList != null){
            canvas.drawLines(dataList,linePaint);

            int j =0;
            for (int i = 0; i < dataList2.length;) {
                canvas.drawText(dataList3[j],dataList2[i] -25,dataList2[i+1]-25, textPaint);
                 i = i+2;
                 j =j + 1;
            }
            drawQu(canvas);
            canvas.drawPoints(dataList2,linePaint2);
        }
//        paint.setColor(Color.BLUE);
//        paint.setStrokeWidth(10);
//        paint.setStyle(Paint.Style.STROKE);
//        paint.setTextSize(50);
//        canvas.drawPoints(point,paint);
//
//        float[] points = {20, 20, 120, 20, 70, 20, 70, 120, 20, 120, 120, 120, 150, 20, 250, 20, 150, 20, 150, 120, 250, 20, 250, 120, 150, 120, 250, 120};
//        canvas.drawLines(points, paint);

//        canvas.drawLines(lines,paint);
//        canvas.drawText("Hello",800,350,paint);
//        canvas.drawCircle(250,250,200,paint);//画圆 cx ,cy 代表圆心位置
//        canvas.drawRect(50,300,300,150,paint);
//        canvas.drawLine(100,100,250,250,paint); //画线
    }

    private Paint linePaint; //画线,
    private Paint linePaint2; //画线
    private Paint zhouPaint; //画轴
//    private Paint gePaint; //
    private Paint textPaint; //画文字
    private void initPaint(){
        linePaint = new Paint();
        linePaint.setStyle(Paint.Style.FILL_AND_STROKE);
        linePaint.setColor(Color.RED);
        linePaint.setStrokeWidth(10);
        linePaint.setARGB(100,255,0,0);
        linePaint.setStrokeJoin(Paint.Join.ROUND);//线条连接处样式
        linePaint.setStrokeCap(Paint.Cap.ROUND); //设置线头样式


        linePaint2 = new Paint();
        linePaint2.setStyle(Paint.Style.FILL_AND_STROKE);
        linePaint2.setColor(Color.RED);
        linePaint2.setStrokeWidth(20);
        linePaint2.setStrokeCap(Paint.Cap.ROUND);


        textPaint = new Paint();
        textPaint.setTextAlign(Paint.Align.LEFT);
        //这里设置Paint的颜色后，如果绘制的是字体那就是字体颜色，如果绘制的线条，那就是线条的颜色
        textPaint.setColor(ContextCompat.getColor(getContext(), R.color.black));
        textPaint.setTextSize(50f);
        //设置字体加粗
        textPaint.setTypeface(Typeface.DEFAULT_BOLD);
        textPaint.setStyle(Paint.Style.FILL);
        textPaint.setFlags(Paint.ANTI_ALIAS_FLAG);

        zhouPaint = new Paint();
        zhouPaint.setStyle(Paint.Style.STROKE);
        zhouPaint.setStrokeWidth(5);
        PathEffect pathEffect = new CornerPathEffect(50);
        zhouPaint.setPathEffect(pathEffect);

    }

    private void drawQu(Canvas canvas){
        Path path  = new Path();
        for (int i = 0; i < dataList.length;) {
            path.moveTo(dataList[i],dataList[i+1]);
            path.quadTo((dataList[i] + dataList[i+2])/2,dataList[i+3],dataList[i+2],dataList[i+3]);
            i = i + 4;
        }
        canvas.drawPath(path,zhouPaint);
    }

    private void drawText(){

    }

}